!
      BLOCK DATA                                                          !A07600
!
      COMMON /LAMCHN/ ONEPL,ONEMI,EXPMIN,ARGMIN                           !A03020
!
      DATA ONEPL/1.001/, ONEMI/0.999/, ARGMIN/34./
!                                                                         A07710

      END                                                                 !A07720
      BLOCK DATA cntnm
!
      IMPLICIT REAL*8           (V)                                     ! F00030
!
      COMMON /FILHDR/ XID(10),SECANT,PAVE,TAVE,HMOLID(60),XALTZ(4), &      !F00130
                      WK(60),PZL,PZU,TZL,TZU,WBROAD,DV ,V1 ,V2 ,TBOUND, &   !F00140
                      EMISIV,FSCDID(17),NMOL,LAYER ,YI1,YID(10),LSTWDF    !F00150
!
      Common /share/ HOLN2
!                                                                         F00100
      CHARACTER*8      XID,       HMOLID,      YID 
      REAL*8               SECANT,       XALTZ
!
      character*8 holn2
!
      DATA HMOlid/ '  H2O   ' , '  CO2   ' , '   O3   ' , '  N2O   ' ,  &  !A12260
                   '   CO   ' , '  CH4   ' , '   O2   ' , 53*'        '/
!
      DATA HOLN2 / ' OTHER'/                                              !A19810
!
      end
      SUBROUTINE XINT (V1A,V2A,DVA,A,AFACT,VFT,DVR3,R3,N1R3,N2R3)         !B17520
!                                                                         B17530
!                                                                         B17870
      IMPLICIT REAL*8           (V)                                     ! F00030
!                                                                         B17550
!     THIS SUBROUTINE INTERPOLATES THE A ARRAY STORED                     B17560
!     FROM V1A TO V2A IN INCREMENTS OF DVA USING A MULTIPLICATIVE         B17570
!     FACTOR AFACT, INTO THE R3 ARRAY FROM LOCATION N1R3 TO N2R3 IN       B17580
!     INCREMENTS OF DVR3                                                  B17590
!                                                                         B17600
      COMMON /LAMCHN/ ONEPL,ONEMI,EXPMIN,ARGMIN                           !B17610
      DIMENSION A(*),R3(*)                                                !B17620
!                                                                         B17630
      RECDVA = 1./DVA                                                     !B17640
      ILO = (V1A+DVA-VFT)/DVR3+1.+ONEMI                                   !B17650
      ILO = MAX(ILO,N1R3)                                                 !B17660
      IHI = (V2A-DVA-VFT)/DVR3+ONEMI                                      !B17670
      IHI = MIN(IHI,N2R3)                                                 !B17680
!                                                                         B17690
      DO 10 I = ILO, IHI                                                  !B17700
         VI = VFT+DVR3*FLOAT(I-1)                                         !B17710
         J = (VI-V1A)*RECDVA+ONEPL                                        !B17720
         VJ = V1A+DVA*FLOAT(J-1)                                          !B17730
         P = RECDVA*(VI-VJ)                                               !B17740
         C = (3.-2.*P)*P*P                                                !B17750
         B = 0.5*P*(1.-P)                                                 !B17760
         B1 = B*(1.-P)                                                    !B17770
         B2 = B*P                                                         !B17780
         CONTI = -A(J-1)*B1+A(J)*(1.-C+B2)+A(J+1)*(C+B1)-A(J+2)*B2        !B17790
         R3(I) = R3(I)+CONTI*AFACT                                        !B17800
   10 CONTINUE                                                            !B17810
!                                                                         B17820
      RETURN                                                              !B17830
!                                                                         B17840
      END                                                                 !B17850
      FUNCTION RADFN (VI,XKT)                                             !B17860
!                                                                         B17870
      IMPLICIT REAL*8           (V)                                       !F00030
!                                                                         B17890
!     FUNCTION RADFN CALCULATES THE RADIATION TERM FOR THE LINE SHAPE     B17900
!                                                                         B17910
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC    B17920
!                                                                         B17930
!               LAST MODIFICATION:    12 AUGUST 1991                      B17940
!                                                                         B17950
!                  IMPLEMENTATION:    R.D. WORSHAM                        B17960
!                                                                         B17970
!             ALGORITHM REVISIONS:    S.A. CLOUGH                         B17980
!                                     R.D. WORSHAM                        B17990
!                                     J.L. MONCET                         B18000
!                                                                         B18010
!                                                                         B18020
!                     ATMOSPHERIC AND ENVIRONMENTAL RESEARCH INC.         B18030
!                     840 MEMORIAL DRIVE,  CAMBRIDGE, MA   02139          B18040
!                                                                         B18050
!----------------------------------------------------------------------   B18060
!                                                                         B18070
!               WORK SUPPORTED BY:    THE ARM PROGRAM                     B18080
!                                     OFFICE OF ENERGY RESEARCH           B18090
!                                     DEPARTMENT OF ENERGY                B18100
!                                                                         B18110
!                                                                         B18120
!      SOURCE OF ORIGINAL ROUTINE:    AFGL LINE-BY-LINE MODEL             B18130
!                                                                         B18140
!                                             FASCOD3                     B18150
!                                                                         B18160
!                                                                         B18170
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC   B18180
!                                                                         !B18190
      COMMON /LAMCHN/ ONEPL,ONEMI,EXPMIN,ARGMIN                           !B18200
!                                                                         !B18210
!      IN THE SMALL XVIOKT REGION 0.5 IS REQUIRED                         !B18220
!                                                                         !B18230
      XVI = VI                                                            !B18240
!                                                                         !B18250
      IF (XKT.GT.0.0) THEN                                                !B18260
!                                                                         !B18270
         XVIOKT = XVI/XKT                                                 !B18280
!                                                                         !B18290
         IF (XVIOKT.LE.0.01) THEN                                         !B18300
            RADFN = 0.5*XVIOKT*XVI                                        !B18310
!                                                                         !B18320
         ELSEIF (XVIOKT.LE.10.0) THEN                                     !B18330
            EXPVKT = EXP(-XVIOKT)                                         !B18340
            RADFN = XVI*(1.-EXPVKT)/(1.+EXPVKT)                           !B18350
!                                                                         !B18360
         ELSE                                                             !B18370
            RADFN = XVI                                                   !B18380
         ENDIF                                                            !B18390
!                                                                         !B18400
      ELSE                                                                !B18410
         RADFN = XVI                                                      !B18420
      ENDIF                                                               !B18430
!                                                                         !B18440
      RETURN                                                              !B18450
!                                                                         !B18460
      END                                                                 !B18470
!*******
!*******
!*******
!      Include 'contnm.f90'
